<template lang="pug">
.modal.is-active( v-if='active' )
	.modal-background( @click='emit("close")' )
	.modal-content
		b-card( title="Выбор группы" )
			.block
				b-field( label="Фильтр по названию группы" )
					b-input( v-model='keyword' )
			.block
				b-table( :data='groups' :columns='columns' :loading='pending' @row-click='emit("select", $event)' )
					template( #clients='{ item }' ) {{ item.clients.length }}
					template( #empty ) Группы не найдены

				b-pagination( v-model='page' :total='last_page' )
	.modal-close( @click='emit("close")' )
</template>

<script setup>
import BTable from "@/components/table/Table.vue"
import BPagination from "@/components/table/Pagination.vue"
import BField from "@/components/form/Field.vue"
import BInput from "@/components/form/Input.vue"

import { ref, watch, computed, onMounted } from "vue"
import { useGroupStore } from "@/stores/group"

const props = defineProps({
	active: Boolean
})

const emit = defineEmits([ "select", "close" ])

const columns = [
	{
		label: "ID",
		field: "id"
	},
	{
		label: "Название",
		field: "name"
	},
	{
		label: "Кол-во пользователей",
		field: "clients"
	}
]

const gs = useGroupStore()

const pending = ref(false)

const groups = computed(() => gs.groups)
const last_page = computed(() => gs.last_page)
const page = computed({
	get: () => gs.page,
	set: val => gs.page = val
})
const keyword = computed({
	get: () => gs.filter,
	set: val => gs.filter = val
})

const fetch = async () => {
	gs.filter_type = "name"
	gs.limit = 15

	pending.value = true
	await gs.getGroups()
	pending.value = false
}

watch(page, fetch)
watch(keyword, () => {
	page.value = 1
	fetch()
})
watch(() => props.active, () => {
	page.value = 1
	fetch()
})

onMounted(fetch)
</script>

<style lang="scss" scoped>
.modal-content {
	width: 90%;
	max-width: 1200px;
	:deep(.table) {
		td:first-of-type,
		th:first-of-type {
			width: 3rem;
		}
		tr {
			cursor: pointer;
		}
	}
}
</style>